= Browsers =
[[TOC(heading=About SecureCI™,depth=2,AboutSecureCI/*)]]

<% if ::File.directory?("#{node['browser']['firefox']['install']}") %>
== Firefox ==
[https://www.mozilla.org/en-US/about/ Mozilla Firefox] is a web browser.
The Ubuntu desktop, 64 bit version is currently installed on this SecureCI™ box.

<% end %>
<% if ::File.directory?("#{node['browser']['chrome']['install']}") %>
== Chrome ==
[https://support.google.com/chrome/answer/3090029?ref_topic=3097320&rd=1 Google Chrome] is a web browser.
The Ubuntu desktop, 64 bit version is currently installed on this SecureCI™ box.

== Chromedriver ==
The [https://code.google.com/p/selenium/wiki/ChromeDriver Chromedriver] consists of three separate pieces. 
There is the browser itself ("chrome"), the language bindings provided by the Selenium project ("the driver") and an executable downloaded from the Chromium project which acts as a bridge between "chrome" and the "driver". 
This executable is called "chromedriver". All three of these pieces are already installed on this SecureCI™ box.

Since the !ChromeDriver implements the wire protocol, it is fully compatible with any !RemoteWebDriver client. Simply start up the !ChromeDriver executable (that works as a server), create a client, and away you go:
{{{
WebDriver driver = new RemoteWebDriver("http://localhost:9515", DesiredCapabilities.chrome());
driver.get("http://www.google.com");
}}}

<% end %>
== Xvfb ==
Xvfb or X virtual framebuffer is a display server implementing the X11 display server protocol. 
In contrast to other display servers Xvfb performs all graphical operations in memory without showing any screen output. 
From the point of view of the client, it acts exactly like any other X display server, serving requests and sending events and errors as appropriate. 
However, no output is shown. This virtual server does not require the computer it is running on to have a screen or any input device. 
Only a network layer is necessary.

=== Usage Scenarios ===
Xvfb is primarily used for testing:
 * Since it shares code with the real X server, it can be used to test the parts of the code that are not related to the specific hardware.
 * It can be used to test clients in various conditions that would otherwise require a range of different hardware; for example, it can be used to test whether clients work correctly at depths or screen sizes that are rarely supported by hardware.
 * Background running of clients. (the xwd program or a similar program for capturing a screenshot can be used to actually see the result)
 * Running programs that require an X server to be active even when they do not use it. (e.g. Clover html reports)

=== Usage Examples ===
==== Take a screenshot ====
As an example, the following sequence of commands runs the virtual framebuffer as display ":1", runs a program on it, and captures the virtual screen in the file image.png using the import command of !ImageMagick:
{{{
Xvfb :1 &
xv -display :1 &
import -display :1 -window root image.png
}}}
The result can be shown by running display image.png or xv image.png. The wrapper script xvfb-run is often used to automate the process of finding an available display and managing authentication.
==== Remote Control over SSH ====
Xvfb is also used for remote control. 
VNC over SSH is slightly[vague] faster than X11 over SSH. In this case, Xvfb is often combined with a lightweight window manager such as Fluxbox and a VNC server such as X11vnc. 
A possible sequence of commands to start this on the server is:
{{{
export DISPLAY=:1
Xvfb :1 -screen 0 1024x768x16 &
fluxbox &
x11vnc -display :1 -bg -nopw -listen localhost -xkb
}}}
The next step is to fire up a SSH client such as PuTTY with tunneling to localhost port 5900 enabled. 
A vncviewer can then connect to localhost to get remote control over the server.
{{{
ssh -N -T -L 5900:localhost:5900 user@remotehost &
vncviewer -encodings 'copyrect tight zrle hextile' localhost:5900
}}}

 * [HowTo/UseXvfb How do I use Xvfb to test my web application on a browser?]

<%= node['trac']['wiki']['footer'] %>